
class TEST
inherit
	EV_ANY_HANDLER
		export
			{NONE} all
		end
	DOUBLE_MATH
		export
			{NONE} all
		end

create
	start
feature
	start (args: ARRAY [STRING]) is
		do
			create application
			create rectangle
			create titled_window
			titled_window.set_size (800, 800)
			titled_window.move_actions.extend (agent handle_window_move)
			titled_window.resize_actions.extend (agent handle_window_resize)
			titled_window.pointer_enter_actions.extend (agent handle_window_pointer_enter)
			create drawing_area
			titled_window.extend (drawing_area)
			drawing_area.expose_actions.extend (agent handle_expose)
			drawing_area.resize_actions.extend (agent handle_resize)
			titled_window.extend (drawing_area)

			titled_window.show
			application.launch
		end

	handle_window_move (a_x, a_y, a_width, a_height: INTEGER) is
		do
			x_position := a_x
			y_position := a_y
			print ("Window moved - upper left now at (" + x_position.out + ", " + y_position.out + ") and size is (" + a_width.out + ", " + a_height.out + ")%N")
		end

	handle_window_resize (a_x, a_y, a_width, a_height: INTEGER) is
		do
			x_position := a_x
			y_position := a_y
			print ("Window resized - upper left now at (" + x_position.out + ", " + y_position.out + ") and size is (" + a_width.out + ", " + a_height.out + ")%N")
		end

	handle_resize (a_x, a_y, a_width, a_height: INTEGER) is
		do
			create pixmap.make_with_size (a_width, a_height)
			redraw
			print ("Resized drawing area to (" + a_width.out + ", " + a_height.out + ") at (" + a_x.out + ", " + a_y.out + ")%N")
		end

	handle_expose (a_x, a_y, a_width, a_height: INTEGER) is
		do
			print ("Expose of drawing area (" + a_width.out + ", " + a_height.out + ") at (" + a_x.out + ", " + a_y.out + ")%N")
			rectangle.move_and_resize (a_x, a_y, a_width, a_height)
			drawing_area.draw_sub_pixmap (a_x, a_y, pixmap, rectangle)
		end

	handle_window_pointer_enter is
		do
			drawing_area.set_focus
		end

	redraw is
		do
			pixmap.clear
			drawing_area.draw_pixmap (0, 0, pixmap)
		end

	x_position: INTEGER

	y_position: INTEGER

	titled_window: EV_TITLED_WINDOW
	
	application: EV_APPLICATION
	
	drawing_area: EV_DRAWING_AREA
	
	pixmap: EV_PIXMAP
	
	rectangle: EV_RECTANGLE
	
end


